#ifndef __PRINT_H__
#define __PRINT_H__

void printHex(Int32U hexNum);
void printUint32(Int32U intNum);
void printString(char *ptr);
void printStringHex(char *ptr, Int32U u32Hex);
void printChar(const Int8U letter);

//
// Macros for printing debug messages.
//
#define _DBG_PRINTX_ARG(arg...) arg /* unroll the parens around the var args*/
#define RETAILMSG(x,y) \
    ((x) ? (snprintf(stringbuffer, PRINTBUFMAX, _DBG_PRINTX_ARG y), printString(stringbuffer)) : 0)
#define PRINTBUFMAX 128
#define PRINT_DEFINEBUFFER() char stringbuffer[PRINTBUFMAX]
#define PRINT_BUFFER() extern char stringbuffer[]

#ifdef DEBUG
#define DEBUGMSG(x,y) \
    ((x) ? (snprintf(stringbuffer, PRINTBUFMAX, _DBG_PRINTX_ARG y), printString(stringbuffer)) : 0)
#else // DEBUG
    #define DEBUGMSG(x,y) (0)
#endif // DEBUG

#endif /* __PRINT_H__ */
